
-- Feel free to modify these messages, but keep the syntax intact. 
-- The curly brackets will be replaced with the character name who announced the achievement in the guild chat.

-- example: "Hallo {}", transforms to "Hallo Wurzelpeter"

local messages = {
    "Dafür hab ich ewig gebraucht {}, gz!",
    "Willkommen im Club {}",
    "Ich weiß noch genau als ich das gemacht habe, {}, gz!",
    "Gut gemacht {}, nun haben wir es beide",
    "Das ist eine Reifeprüfung, {}",
    "Gut gemacht {}",
    "Grats {}",
    "Wow {} das ist großartig!",
    "Gz {}! Den brauch ich noch",
    "Den hätt ich auch gerne {}"
}


-- ### DO NOT CHANGE #################################################################

function get_random_message(messages)
    return messages[math.random(#messages)]
end

function insert_character_name(message, full_char_name)
    local char_name = get_character_name(full_char_name)
    return message:gsub("%{}", char_name)
end

function get_character_name(full_name)
    local index_dash = string.find(full_name, "-")
    if index_dash == nil then
        return full_name
    else
        return string.sub(full_name, 1, index_dash-1)
    end
end

function get_message(messages, full_name)
    local message = get_random_message(messages)
    return insert_character_name(message, full_name)
end

function trim(str)
    return string.gsub(str, "^%s*(.-)%s*$", "%1")
end

function starts_with(message, prefix)
    local low_message = string.lower(message)
    local low_prefix = string.lower(prefix)
    local substring = string.sub(low_message, 1, #low_prefix)
    if substring == low_prefix then
        return true
    else
        return false
    end
end

function live_debugging(...)
     local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 = ...
     print(arg1)
     print(arg2)
     print(arg3)
     print(arg4)
     print(arg5)
     print(arg6)
     print(arg7)
     print(arg8)
     print(arg9)
     print(arg10)
     print(arg11)
     print(arg12)

    local message = arg1
    local author = arg2

     -- skip if I am the author
     local char_name = GetUnitName("player", false)
     if starts_with(author, char_name) then
     return
     end

    for k, v in pairs(communications) do
        if starts_with(message, trim(k)) then
            local reply = "_" .. insert_character_name(v, author)
            print(reply)
            SendChatMessage(reply, "SAY", nil, nil);
            break
        end
    end
end

local function eventHandler(self, event, ...)

    -- for debugging only
--    if event == "CHAT_MSG_SAY" then
--        live_debugging(...)
--    end

    if event == "CHAT_MSG_GUILD_ACHIEVEMENT" then
        local event_message, guildmember_name = ...
        local reply = get_message(messages, guildmember_name);
        SendChatMessage(reply, "GUILD", nil, nil);
    end
end

local frame = CreateFrame("FRAME", "MrNiceGuy");
--frame:RegisterEvent("CHAT_MSG_SAY");
frame:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT");
frame:SetScript("OnEvent", eventHandler);
